Name:           google-gson
Version:        2.10.1
Release:        %mkrel 3
Group:          Development/Java
Summary:        Java lib for conversion of Java objects into JSON representation
License:        ASL 2.0
URL:            https://github.com/google/gson
Source0:        https://github.com/google/gson/archive/gson-parent-%{version}.tar.gz

# Internal packages are naughtily used by other packages in Fedora
Patch1: 0002-Also-export-internal-packages-in-OSGi-metadata.patch
# Remove dependency on unavailable templating-maven-plugin
# Reverts upstream commit https://github.com/google/gson/commit/d84e26d
Patch3: 0004-This-commit-added-a-dependency-on-templating-maven-p.patch

BuildArch:      noarch
#ExclusiveArch:  %%{java_arches} noarch

BuildRequires:  maven-local
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-jar-plugin)
BuildRequires:  bnd-maven-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  mvn(com.fasterxml.jackson.core:jackson-databind)

%description
Gson is a Java library that can be used to convert a Java object into its
JSON representation. It can also be used to convert a JSON string into an
equivalent Java object. Gson can work with arbitrary Java objects including
pre-existing objects that you do not have source-code of.

%package javadoc
Summary:        API documentation for %{name}

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n gson-gson-parent-%{version}
#rm ./gradle/wrapper/gradle-wrapper.jar
%patch -P 1 -p1
%patch -P 3 -p1

# The test EnumWithObfuscatedTest requires the plugins copy-rename-maven-plugin, proguard-maven-plugin and maven-resources-plugin to work correctly because it tests Gson interaction with a class obfuscated by ProGuard.
# https://github.com/google/gson/issues/2045
rm ./gson/src/test/java/com/google/gson/functional/EnumWithObfuscatedTest.java

# to check later
rm ./gson/src/test/java/com/google/gson/internal/bind/DefaultDateTypeAdapterTest.java
# remove unnecessary dependency on parent POM
# POM doesn't specify parent.
#%%pom_remove_parent

%pom_remove_plugin :copy-rename-maven-plugin gson
%pom_remove_plugin :proguard-maven-plugin gson

%pom_remove_plugin  :moditect-maven-plugin gson

# Remove dependency on unavailable templating-maven-plugin
%pom_remove_plugin  org.codehaus.mojo:templating-maven-plugin gson
rm gson/src/test/java/com/google/gson/internal/GsonBuildConfigTest.java
rm gson/src/test/java/com/google/gson/functional/GsonVersionDiagnosticsTest.java

# to fix error: package javax.annotation is not visible import javax.annotation.PostConstruct;
rm extras/src/main/java/com/google/gson/typeadapters/PostConstructAdapterFactory.java
rm extras/src/test/java/com/google/gson/typeadapters/PostConstructAdapterFactoryTest.java

#depends on com.google.caliper
%pom_disable_module metrics

#depends on com.google.protobuf:protobuf-java:jar:4.0.0-rc-2 and com.google.truth:truth:jar:1.1.3
%pom_disable_module proto

for x in `find | grep pom.xml` ; do
  if cat $x | grep -e "<maven.compiler.release>.*7" ; then
    sed "s;<maven.compiler.release>.*7.*;<maven.compiler.release>8</maven.compiler.release>;g" -i $x;
  fi
  if cat $x | grep -e "<failOnWarning>.*true" ; then
    sed "s;<failOnWarning>.*true.*;<failOnWarning>false</failOnWarning>;g" -i $x;
  fi
done


%build
%mvn_build -f

%install
%mvn_install

%files -f .mfiles
%license LICENSE
%doc README.md CHANGELOG.md UserGuide.md

%files javadoc  -f .mfiles-javadoc
%license LICENSE




%changelog
* Sun Jun 29 2025 umeabot <umeabot> 2.10.1-3.mga10
+ Revision: 2223806
- Mageia 10 Mass Rebuild

* Thu May 23 2024 ns80 <ns80> 2.10.1-2.mga10
+ Revision: 2066680
- rebuild for java 21

* Thu Sep 14 2023 daviddavid <daviddavid> 2.10.1-1.mga10
+ Revision: 1986766
- Update google-gson to 2.10.1

* Thu Dec 08 2022 daviddavid <daviddavid> 2.9.1-1.mga9
+ Revision: 1919608
- Update google-gson to 2.9.1 (#2112775)
- Refactor patch 0004 , to not use patch to delete files and add a new hunk
- Reenable javadoc sub-package

* Mon Aug 08 2022 neoclust <neoclust> 2.9.0-1.mga9
+ Revision: 1876097
- New version 2.9.0
+ umeabot <umeabot>
- Mageia 9 Mass Rebuild

* Fri Sep 04 2020 daviddavid <daviddavid> 2.8.6-1.mga8
+ Revision: 1621553
- Update to version 2.8.6
- Remove unnecessary dependency on parent POM
- fixed javadoc to build on jdk11
- Rebuilt for JDK-11
- Add patch to prevent hard OSGi dep on 'sun.misc' package

* Fri Feb 14 2020 umeabot <umeabot> 2.8.2-2.mga8
+ Revision: 1519999
- Mageia 8 Mass Rebuild

* Wed Oct 31 2018 daviddavid <daviddavid> 2.8.2-1.mga7
+ Revision: 1326830
- new version: 2.8.2 (sync with fc29)

* Tue Sep 18 2018 umeabot <umeabot> 2.3.1-6.mga7
+ Revision: 1260973
- Mageia 7 Mass Rebuild

* Sun May 14 2017 neoclust <neoclust> 2.3.1-5.mga6
+ Revision: 1101331
- Skip default jar plugin execution to fix FTBFS

* Wed Mar 02 2016 neoclust <neoclust> 2.3.1-4.mga6
+ Revision: 981859
- Second rebuild of the java stack

* Tue Feb 23 2016 neoclust <neoclust> 2.3.1-3.mga6
+ Revision: 976283
- First rebuild of the java stack
- sync package google-gson with fedora
+ umeabot <umeabot>
- Mageia 6 Mass Rebuild

* Thu Dec 25 2014 pterjan <pterjan> 2.2.4-6.mga5
+ Revision: 805781
- Clean rebuild
- Sync with Fedora 21
- Restore
+ sander85 <sander85>
- Depends on broken java stack

* Wed Oct 15 2014 umeabot <umeabot> 2.2.4-4.mga5
+ Revision: 750627
- Second Mageia 5 Mass Rebuild
- Mageia 5 Mass Rebuild

* Tue Oct 22 2013 umeabot <umeabot> 2.2.4-2.mga4
+ Revision: 545007
- Mageia 4 Mass Rebuild

* Tue Oct 15 2013 dmorgan <dmorgan> 2.2.4-1.mga4
+ Revision: 500606
- New version

* Thu Jul 11 2013 dmorgan <dmorgan> 2.2.2-1.mga4
+ Revision: 452941
- New version

* Sat Jan 12 2013 umeabot <umeabot> 2.2.1-2.mga3
+ Revision: 352452
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Sep 12 2012 dmorgan <dmorgan> 2.2.1-1.mga3
+ Revision: 292692
- New version

* Tue Jul 19 2011 dmorgan <dmorgan> 1.7.1-3.mga2
+ Revision: 126853
- imported package google-gson


* Fri May 13 2011 Jaromir Capik <jcapik@redhat.com> - 1.7.1-3
- Removal of failing testInetAddressSerializationAndDeserialization

* Wed May 11 2011 Jaromir Capik <jcapik@redhat.com> - 1.7.1-2
- Conversion of CR+LF to LF in the license file

* Tue May 10 2011 Jaromir Capik <jcapik@redhat.com> - 1.7.1-1
- Initial version of the package
